/*==========================================================================
*
*  Example_1 - demo application
*  by Branislav Lehotsky
*  Demonstration of using BonbliotFramework (c)
*  - is showing one DUI component, you can setup its design interactive way (for studying of working with the DUI)
*
*  Example_1 - demontran apka
*  Branislav Lehotsk
*  Demontruje pouitie BonbliotFramework (c)
*  - zobraz sa jedna DUI komponenta, ktorej dizajn mono interaktvne meni (na tdium prce s DUI)
*
*==========================================================================
*/
#include <ddraw.h>     //Direct Draw 
#include <mmsystem.h>  //koli LPWAVEFORMATEX v <dsound.h> a.i.
#include <dsound.h>    //Direct Sound

//---------------------- //hlavicka hlavnej kniznice, FrameWork by Bonbliot (c)
//#include "..\_BonbliotFramework_v3_1\DBonbliotFW.h"
#include "DBonbliotFW.h"    
//----------------------

#define IDC_BTN_1      100

#define IDC_LOOK_1     101
#define IDC_LOOK_2     102
#define IDC_LOOK_3     103
#define IDC_LOOK_4     104
#define IDC_LOOK_5     105
#define IDC_LOOK_6     106

#define IDC_CONTENT_1  111
#define IDC_CONTENT_2  112

#define IDC_BACKGR_1   121
#define IDC_BACKGR_2   122
#define IDC_BACKGR_3   123

#define IDC_FONT_1     131
#define IDC_FONT_2     132
#define IDC_FONT_3     133

#define def_pi   3.14159265

bool pravedole;

//----------------------------------------------------------------
// App
//----------------------------------------------------------------
class CMyApp : public bf_CAppScreen
{
public:
  bf_CDUI * dui_X;
  bf_CButton * tlac_SH;

  bf_CSwitch *rb_look_1;
  bf_CSwitch *rb_look_2;
  bf_CSwitch *rb_look_3;
  bf_CSwitch *rb_look_4;
  bf_CSwitch *rb_look_5;
  bf_CSwitch *rb_look_6;
  bf_CSwitch *rb_content_1;
  bf_CSwitch *rb_content_2;
  bf_CSwitch *rb_backgr_1;
  bf_CSwitch *rb_backgr_2;
  bf_CSwitch *rb_backgr_3;
  bf_CSwitch *rb_font_1, *rb_font_2, *rb_font_3;
  
  bf_CLabel *lab1, *lab2;
  bf_CDecor *dcH, *dc1, *dc2, *dc3, *dc4;

  bf_CDas_Surface  emoticons_srf;

  CMyApp(HINSTANCE hInstance, int nCmdShow, char* cLocApp_INI);
  //~CMyApp();
  virtual void Do_LOAD_SRF();
  virtual void Do_RELEASE_SRF();
  virtual void Do_RESTORE_SRF();
  void NAPLN_DUI(int zdroj);
  virtual void Init();
  virtual int SetupVisual();
  //virtual void Init2();
  virtual void HandleWMInteraction(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
  virtual bool HandleFWInteraction(int iID, int ivalue, bf_CPos *p_pol = NULL);
  virtual void ChangedResolution(int maxx_old, int maxy_old, int maxx_new, int maxy_new);
  //virtual void Redraw_Screen(LPDIRECTDRAWSURFACE p_lpDDS);
  //virtual void DrawCursor(LPDIRECTDRAWSURFACE p_lpDDS);
};


//----------------------------------------------------------------
// Konstruktor
//----------------------------------------------------------------
CMyApp::CMyApp(HINSTANCE hInstance, int nCmdShow, char* cLocApp_INI) : bf_CAppScreen(hInstance, nCmdShow, cLocApp_INI)
{
   dui_X = new bf_CDUI(this, 200, 50);
   dui_X->autohide = false;

   rb_look_1 = new bf_CSwitch(this, IDC_LOOK_1);
   rb_look_2 = new bf_CSwitch(this, IDC_LOOK_2);
   rb_look_3 = new bf_CSwitch(this, IDC_LOOK_3);
   rb_look_4 = new bf_CSwitch(this, IDC_LOOK_4);
   rb_look_5 = new bf_CSwitch(this, IDC_LOOK_5);
   rb_look_6 = new bf_CSwitch(this, IDC_LOOK_6);

   rb_content_1 = new bf_CSwitch(this, IDC_CONTENT_1);
   rb_content_2 = new bf_CSwitch(this, IDC_CONTENT_2);

   rb_backgr_1 = new bf_CSwitch(this, IDC_BACKGR_1);
   rb_backgr_2 = new bf_CSwitch(this, IDC_BACKGR_2);
   rb_backgr_3 = new bf_CSwitch(this, IDC_BACKGR_3);
      
   rb_font_1 = new bf_CSwitch(this, IDC_FONT_1);
   rb_font_2 = new bf_CSwitch(this, IDC_FONT_2);
   rb_font_3 = new bf_CSwitch(this, IDC_FONT_3);

   lab1 = new bf_CLabel(this, -1);
   lab2 = new bf_CLabel(this, -1);
   dcH = new bf_CDecor(this);
   dc1 = new bf_CDecor(this);
   dc2 = new bf_CDecor(this);
   dc3 = new bf_CDecor(this);
   dc4 = new bf_CDecor(this);

   tlac_SH = new bf_CButton(this, IDC_BTN_1);
};

//----------------------------------------------------------------
// destruktor
//----------------------------------------------------------------
//CMyApp::~CMyApp()
//{
//};

//----------------------------------------------------------------
// nahratie SRF
//----------------------------------------------------------------
void CMyApp::Do_LOAD_SRF()
{
  emoticons_srf.LOAD_SURFACE((char*) "emoticons.bmp");
  emoticons_srf.BC_SET(0, 0);
  emoticons_srf.TC_SET(3, 3);
};

//----------------------------------------------------------------
// Uvolnit vsetky objekty surfaces
//----------------------------------------------------------------
void CMyApp::Do_RELEASE_SRF()
{
  emoticons_srf.RELEASE_SURFACE();
}

//----------------------------------------------------------------
// Restore objektov surfaces
//----------------------------------------------------------------
void CMyApp::Do_RESTORE_SRF()
{
  emoticons_srf.RESTORE_SURFACE();
}

//----------------------------------------------------------------
// Naplnenie DUI
//----------------------------------------------------------------
void CMyApp::NAPLN_DUI( int zdroj )
{
  if ( zdroj == 1 )
  {
    bf_Set_CIcon_default_transparency(0);

    dui_X->ADD(1, (char*) "Picture 1 Sea",    (char*) "pict1.bmp");
    dui_X->ADD(2, (char*) "Picture 2 Desert", (char*) "pict2.bmp");
    dui_X->ADD(3, (char*) "Picture 3 Moon",   (char*) "pict3.bmp");
    dui_X->ADD(4, (char*) "Picture 4 Mountains", (char*) "pict4.bmp");
    dui_X->ADD(5, (char*) "Picture 5 Beach",  (char*) "pict5.bmp");
    dui_X->ADD(6, (char*) "Picture 6 Lake",   (char*) "pict6.bmp");
    dui_X->ADD(7, (char*) "Picture 7 Castle", (char*) "pict7.bmp");
    //dui_X->ADD(8, (char*) "Picture 8 Hotel", (char*) "pict8.bmp");
    //dui_X->ADD(9, (char*) "Picture 9 Car race", (char*) "pict9.bmp");
  }
  else if (zdroj == 2)
  {
     //bf_Set_CIcon_default_transparency(1);

     dui_X->ADD(1, (char*) "Emoticon 1", new bf_CIcon(&emoticons_srf, 30, 30), true);
     dui_X->ADD(2, (char*) "Emoticon 2", new bf_CIcon(&emoticons_srf, 100, 30), true);
     dui_X->ADD(3, (char*) "Emoticon 3", new bf_CIcon(&emoticons_srf, 170, 30), true);
     dui_X->ADD(4, (char*) "Emoticon 4", new bf_CIcon(&emoticons_srf, 240, 30), true);
     dui_X->ADD(5, (char*) "Emoticon 5", new bf_CIcon(&emoticons_srf, 30, 100), true);
     dui_X->ADD(6, (char*) "Emoticon 6", new bf_CIcon(&emoticons_srf, 100, 100), true);
     dui_X->ADD(7, (char*) "Emoticon 7", new bf_CIcon(&emoticons_srf, 170, 100), true);
  }
}

//----------------------------------------------------------------
// Init inicializacie
//----------------------------------------------------------------
void CMyApp::Init()
{
  //bf_LOG_SetONOFF(1); //zapiname log 
  NAPLN_DUI(1);      //pociatocne naplnenie dui
}

//----------------------------------------------------------------
// Nastavi vizual, dizajn dialogu
//----------------------------------------------------------------
int CMyApp::SetupVisual()
{
  bf_CAppScreen::SetupVisual(); //obsluzit najprv predka (od koho je App odvodena)

  lab1->Dsgn(200, 100, (char*)"DUI demo");
  lab1->CR_text_color = RGB(100, 180, 100);
  lab1->font_hnd = bf_DSGN_CreateFont(75, 40, FW_NORMAL, "Verdana");
  lab1->GO_TO_CENTER(bf_Get_SX(), 100);

  dui_X->autohide = false;
  //dui_X->font_hnd = bf_DSGN_CreateFont(15, 8, FW_BOLD, "Verdana");
  dui_X->GO_TO_CENTER( bf_Get_SY(), bf_Get_SY() );
  
  int xx = 900; int yy = 300; int dy = 24;

  lab2->Dsgn(885, 240, (char*)"Select look of DUI:");
  lab2->CR_text_color = RGB(255, 255, 255);
  
  rb_look_1->Dsgn(1, xx, yy);  yy += dy;
  rb_look_1->Dsgn_label(20, -1, (char*)"vertical default", RGB(255, 255, 255));
  rb_look_2->Dsgn(1, xx, yy);  yy += dy;
  rb_look_2->Dsgn_label(20, -1, (char*)"vertical my", RGB(255, 255, 255));
  rb_look_3->Dsgn(1, xx, yy);  yy += dy;
  rb_look_3->Dsgn_label(20, -1, (char*)"horizontal default", RGB(255, 255, 255));
  rb_look_4->Dsgn(1, xx, yy);  yy += dy;
  rb_look_4->Dsgn_label(20, -1, (char*)"horizontal my", RGB(255, 255, 255));
  rb_look_5->Dsgn(1, xx, yy);  yy += dy;
  rb_look_5->Dsgn_label(20, -1, (char*)"tabular default", RGB(255, 255, 255));
  rb_look_6->Dsgn(1, xx, yy);  yy += dy;
  rb_look_6->Dsgn_label(20, -1, (char*)"free my", RGB(255, 255, 255));
  yy += dy;
  int group = 1;
  rb_content_1->Dsgn(1, xx, yy, group);  yy += dy;
  rb_content_1->Dsgn_label(20, -1, (char*)"thumbnails", RGB(255, 255, 255));
  rb_content_2->Dsgn(1, xx, yy, group);  yy += dy;
  rb_content_2->Dsgn_label(20, -1, (char*)"emoticons", RGB(255, 255, 255));
  yy += dy;
  group = 2;
  rb_backgr_1->Dsgn(1, xx, yy, group);  yy += dy;
  rb_backgr_1->Dsgn_label(20, -1, (char*)"transparent background", RGB(255, 255, 255));
  rb_backgr_2->Dsgn(1, xx, yy, group);  yy += dy;
  rb_backgr_2->Dsgn_label(20, -1, (char*)"solid background", RGB(255, 255, 255));
  rb_backgr_3->Dsgn(1, xx, yy, group);  yy += dy;
  rb_backgr_3->Dsgn_label(20, -1, (char*)"no background", RGB(255, 255, 255));
  yy += dy;
  group = 3;
  rb_font_1->Dsgn(1, xx, yy, group);  xx += 80;
  rb_font_1->Dsgn_label(20, -1, (char*)"font 1", RGB(255, 255, 255));
  rb_font_2->Dsgn(1, xx, yy, group);  xx += 80;
  rb_font_2->Dsgn_label(20, -1, (char*)"font 2", RGB(255, 255, 255));
  rb_font_3->Dsgn(1, xx, yy, group);  xx += 80;
  rb_font_3->Dsgn_label(20, -1, (char*)"font 3", RGB(255, 255, 255));
  
  rb_look_1->SetCheck(true);
  rb_content_1->SetCheck(true);
  rb_backgr_1->SetCheck(true);
  rb_font_1->SetCheck(true);

  dcH->Dsgn(885, 255, 255, 0);
  dc1->Dsgn(885, 285, 255, 164);
  dc2->Dsgn(885, 459, 255, 60);
  dc3->Dsgn(885, 529, 255, 84);
  dc4->Dsgn(885, 624, 255, 35);

  tlac_SH->Dsgn0_VoidDC(885, 672,   106, 45);   //default: void_SIR = 100; void_VYS = 45;
  tlac_SH->Dsgn_label(5, 15, (char*)"Show/Hide", RGB(100, 180, 100));

  return 0;
}

//----------------------------------------------------------------
// Spracovanie WM 
//----------------------------------------------------------------
void CMyApp::HandleWMInteraction(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
  int mx,my;
  switch (message)
  {
  case WM_RBUTTONDOWN:      //pravy klik mysou DOWN
    mx = LOWORD(lParam);
    my = HIWORD(lParam);
    dui_X->GO_TO_CENTER(mx, my);
    pravedole = true;
    break;

  case WM_RBUTTONUP:      //pravy klik mysou UP
    pravedole = false;
    break;

  case WM_MOUSEMOVE:
    if ( pravedole )
    {
      mx = LOWORD(lParam);
      my = HIWORD(lParam);
      dui_X->GO_TO_CENTER(mx, my);
    }
    break;
  }
}

//----------------------------------------------------------------
// Da priestor na akciu 
//----------------------------------------------------------------
bool CMyApp::HandleFWInteraction(int iID, int ivalue, bf_CPos *p_pol)
{
  //postup cez dimenziu predkov
  bool l_b = bf_CAppScreen::HandleFWInteraction(iID, ivalue, p_pol);  //obsluzit class predka
  int ox, oy;

  switch (iID)
  {
  case IDC_BTN_1:
    dui_X->visible = !dui_X->visible;
    break;


  case IDC_CONTENT_1:  //thumb.
    dui_X->DELETE_ALL();
    NAPLN_DUI(1);
    //rekalkulovat
    if (rb_look_1->GetCheck()) HandleFWInteraction(IDC_LOOK_1, 1, NULL);
    if (rb_look_2->GetCheck()) HandleFWInteraction(IDC_LOOK_2, 1, NULL);
    if (rb_look_3->GetCheck()) HandleFWInteraction(IDC_LOOK_3, 1, NULL);
    if (rb_look_4->GetCheck()) HandleFWInteraction(IDC_LOOK_4, 1, NULL);
    if (rb_look_5->GetCheck()) HandleFWInteraction(IDC_LOOK_5, 1, NULL);
    if (rb_look_6->GetCheck()) HandleFWInteraction(IDC_LOOK_6, 1, NULL);
    break;
  case IDC_CONTENT_2:  //emoticions
    dui_X->DELETE_ALL();
    NAPLN_DUI(2);
    //rekalkulovat
    if (rb_look_1->GetCheck()) HandleFWInteraction(IDC_LOOK_1, 1, NULL);
    if (rb_look_2->GetCheck()) HandleFWInteraction(IDC_LOOK_2, 1, NULL);
    if (rb_look_3->GetCheck()) HandleFWInteraction(IDC_LOOK_3, 1, NULL);
    if (rb_look_4->GetCheck()) HandleFWInteraction(IDC_LOOK_4, 1, NULL);
    if (rb_look_5->GetCheck()) HandleFWInteraction(IDC_LOOK_5, 1, NULL);
    if (rb_look_6->GetCheck()) HandleFWInteraction(IDC_LOOK_6, 1, NULL);
    break;


  case IDC_LOOK_1:
    dui_X->visible = true;
    dui_X->trieda = bf_c_DUI_class_2_VERTICAL;
    //-------------
    dui_X->RESET_DEFAULT();
    //-------------
    dui_X->autohide = false;

   //poloha - centrovanie
    dui_X->GO_TO_CENTER(bf_Get_SY(), bf_Get_SY());
    break;

  case IDC_LOOK_2:
    dui_X->visible = true;
    dui_X->trieda = bf_c_DUI_class_2_VERTICAL;
    dui_X->autohide = false;
    
    //konstanty a, b, c, d
    //dui_X->Set_Constants(52, 60, 200, 20);
    dui_X->Compute_stats();
    dui_X->Set_Constants(52, //max(dui_X->max_text_vys,dui_X->max_icon_vys),
            60,
            dui_X->max_text_sir + dui_X->max_icon_sir + 6,
            20);

    //nastavit default mody a padding-y
    dui_X->SetTextMode((char*)"LC" );  //LeftCenter, padding=1
    dui_X->TextPadding = 1;
    dui_X->SetIconMode((char*)"RC" );  //RightCenter, padding=1
    dui_X->IconPadding = 1;

    //poloha - centrovanie na stred okna
    dui_X->GO_TO_CENTER(bf_Get_SY(), bf_Get_SY());

    break;

  case IDC_LOOK_3:
    dui_X->visible = true;
    dui_X->trieda = bf_c_DUI_class_1_HORIZONTAL;
    //-------------
    dui_X->RESET_DEFAULT();
    //-------------
    dui_X->autohide = false;
    break;

  case IDC_LOOK_4:
    dui_X->visible = true;
    dui_X->trieda = bf_c_DUI_class_1_HORIZONTAL;
    dui_X->autohide = false;

    dui_X->Compute_stats();
    //dui_X->Set_Constants(52, -1, dui_X->max_text_sir + dui_X->max_icon_sir + 6, 3);
    dui_X->Set_Constants(52, -1, -1, 3);

    //poloha - vlavo hore - proste menu pruh
    dui_X->GO_TO(1, 3);

    //nastavit default mody a padding-y
    dui_X->SetIconMode((char*)"RC");  //RightCenter
    dui_X->IconPadding = 1;
    dui_X->SetTextMode((char*)"LC");  //LeftCenter
    dui_X->TextPadding = 8;

    dui_X->treba_RG = true;   //treba RESET_GEOMETRIE  
    dui_X->RESET_GEOMETRY();
    break;

  case IDC_LOOK_5:
    dui_X->visible = true;
    dui_X->trieda = bf_c_DUI_class_3_TABULAR;
    //-------------
    dui_X->RESET_DEFAULT();
    //-------------
    dui_X->autohide = false;

    //poloha - centrovanie
    dui_X->GO_TO_CENTER(bf_Get_SY(), bf_Get_SY());
    break;

  case IDC_LOOK_6:
    dui_X->visible = true;
    dui_X->trieda = bf_c_DUI_class_0_FREE;
    dui_X->autohide = false;

    dui_X->Compute_stats();

    //dui_X->Set_Constants( 80,0,100,30 );
    dui_X->Set_Constants(dui_X->max_text_vys + dui_X->max_icon_vys + 10,
                             0, 
                             max(dui_X->max_text_sir, dui_X->max_icon_sir), 
                             30);

    //nastavit default mody a padding-y
    dui_X->SetTextMode((char*)"CB" );  //CenterBottom, padding=1
    dui_X->TextPadding = 1;
    dui_X->SetIconMode((char*)"CC" );  //CenterCenter, padding=1
    dui_X->IconPadding = 1;

    //---
    int sx, sy, Rx, Ry;
    double alf, dalf;
    sx = bf_Get_SY();
    sy = bf_Get_SY()+100;
    Rx = 300; Ry = 200;
    alf = 0;
    dalf = def_pi / (dui_X->VOL.count - 1);
    bf_TCHOICE *v;
    //rozptylit do polelipsy
    for (int i = 0; i<dui_X->VOL.count; i++)
    {
      ox = sx - int( Rx * cos(alf) ) - dui_X->c / 2;
      oy = sy - int( Ry * sin(alf) ) - dui_X->a / 2;
      RECT rectv = { ox,oy, ox + dui_X->c, oy + dui_X->a };
      v = (bf_TCHOICE*)dui_X->VOL[i];
      v->rect = rectv;
      alf += dalf;
    }
    //podkladovy. rectangle
    //dui_X->backgr_rect = { sx-Rx-dui_X->c/2-dui_X->d, sy-Ry-dui_X->a/2-dui_X->d, sx+Rx+dui_X->c/2+dui_X->d, sy+dui_X->a/2+dui_X->d };
    dui_X->Compute_backgr_rect();

    //poloha
    dui_X->GO_TO(dui_X->backgr_rect.left, dui_X->backgr_rect.top);
    break;


  case IDC_BACKGR_1:
    dui_X->backgr_typ = 1;  //priesvitne sito
    break;
  case IDC_BACKGR_2:
    dui_X->backgr_typ = 2;  //plne
    break;
  case IDC_BACKGR_3:
    dui_X->backgr_typ = 0;  //bez
    break;

  case IDC_FONT_1:
    dui_X->SetFont(15, 9, FW_NORMAL, "Verdana");   //len font DUI
    //bf_DSGN_SetLabelsDefaultFont(15, 9, FW_NORMAL, "Verdana");  //vseobecne font pre lable
    break;
  case IDC_FONT_2:
    dui_X->SetFont(15, 8, FW_NORMAL, "Verdana");
    //bf_DSGN_SetLabelsDefaultFont(15, 8, FW_NORMAL, "Verdana");
    break;
  case IDC_FONT_3:
    dui_X->SetFont(15, 8, FW_BOLD, "Verdana");
    //bf_DSGN_SetLabelsDefaultFont(15, 8, FW_BOLD, "Verdana");
    break;
  }

  return l_b;
}

//----------------------------------------------------------------
// Volane po zmene rozmerov obrazovky
//----------------------------------------------------------------
void CMyApp::ChangedResolution(int maxx_old, int maxy_old, int maxx_new, int maxy_new)
{
  //postup cez dimenziu predkov (vratit funkcnost predkovi, lebo cez virtual bola obidena, prepisana)
  bf_CAppScreen::ChangedResolution(maxx_old, maxy_old, maxx_new, maxy_new);  //obsluzit class predka
  
  //popisku centrovat
  lab1->GO_TO_CENTER(bf_Get_SX(), 100);

  //renaplnit
  if (rb_content_1->GetCheck()) HandleFWInteraction(IDC_CONTENT_1, 1, NULL);
  if (rb_content_2->GetCheck()) HandleFWInteraction(IDC_CONTENT_2, 1, NULL);
}

/*
//----------------------------------------------------------------
// Prekreslit celu scenu 
//----------------------------------------------------------------
void CMyApp::Redraw_Screen(LPDIRECTDRAWSURFACE p_lpDDS)
{
  //<--- vymazat
  //DDSURFACE_ZMAZ(p_lpDDS, 500);
  //emoticons_srf.ZOBRAZ(5, 5);
}
*/
/*
//----------------------------------------------------------------
// Vykreslit kurzor
//----------------------------------------------------------------
void CMyApp::DrawCursor(LPDIRECTDRAWSURFACE p_lpDDS)
{
}
*/

//==============================================================================

//----------------------------------------------------------------
// Vstupny bod pre Appku
//----------------------------------------------------------------
int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
  LPSTR lpCmdLine, int nCmdShow)
{
  //bf_Set_Lang(bf_c_Lang_EN);
  CMyApp *pAPP = new CMyApp(hInstance, nCmdShow, (char*) "EXAMPLE.INI");    //vytvorit instanciu
  pAPP->SetBackground(500, (char*)"", false);   //tmavomodra farba pozadia, ziaden obraz ako podklad, ziadne logo
  pAPP->SetAppInfo((char*)"Example, DUI demo", (char*)"(version: 1.0)", (char*)"Branislav Lehotsk");  //info polia
  pAPP->SetLang( bf_c_Lang_EN );   // bf_c_Lang_EN / bf_c_Lang_SK 
  pAPP->Execute();  //spustit
  delete pAPP;
  return 0;
}
